# --------------------------------------------------------------------
# Automatic process just after invoking
# --------------------------------------------------------------------
proc automatic_process {} {
   # Global ------------------------------
   global wk TMPDIR gbl paste filt file_name print macray

   # Main ------------------------------
   # The execution order is important!!

   # using data set data base?
   if { $wk(invoke,usedb) >= 0 } {
      set gbl(ds,mode) $wk(invoke,usedb)
   }
   if { $wk(invoke,autoDB) } {
      if { $wk(invoke,havepick) == 1 } {
	 set file_name(pick) $wk(invoke,pickfn)
      }
      data_set_create_db_auto
   }
   if { $gbl(ds,mode) == 1 && $wk(invoke,autoDB) == 0 } {
      data_set_update_files
   }
   set flag_drawframe 0
   
   # set path of temporary disk space
   if { $wk(invoke,tmp) != "" } {
      if {[file exist $wk(invoke,tmp)] && [file isdirectory $wk(invoke,tmp)]} {
	 set TMPDIR $wk(invoke,tmp)
      }
   }

   # drawing style
   if { $wk(invoke,style) != "" } {
      set_drawing_style $wk(invoke,style)
   }
   # drawing style2
   if { $wk(invoke,style2) != "" } {
      set_drawing_style2 $wk(invoke,style2)
   }
   # wave density
   if { $wk(invoke,density) != "" } {
      set paste(wave_density) $wk(invoke,density)
   }
   # thinning out
   if { $wk(invoke,thinout) != "" } {
      set paste(wave_distance) $wk(invoke,thinout)
   }

   # Set figure title
   if { $wk(invoke,title) != "" } {
      set paste(label,title) $wk(invoke,title)
      set flag_drawframe 1
   }
	
   # x-axis and t-axis -----
   # x-axis key
   if { $wk(invoke,xaxis) != "" } {
      set gbl(data,xaxis_label) $wk(invoke,xaxis)
      update_xaxis
   }

   # x-tics and t-tics
   foreach {i j} {xtic xtic_int ttic t_tic_int} {
      if { $wk(invoke,$i) != "" } { 
	 set gbl($j) $wk(invoke,$i)
	 set flag_drawframe 1
      }
   }

   # auto
   if { $wk(invoke,autorange) } {
      set tmp $gbl(xtic_int)
      if { $wk(invoke,autorsize) > 0 } { 
	 set gbl(xtic_int) $wk(invoke,autorange)
      }
      auto_offset_range $wk(invoke,range_width)
      set gbl(xtic_int) $tmp
   }

   # t/x ratio
   if { $wk(invoke,txratio) != "" } {
      set paste(default,txratio) $wk(invoke,txratio)
      resize_canvas_size_by_ratio
   }

   # global variable, paste related (x-min,max, t-min,max, rvel)
   foreach {i j} {xmin left xmax right tmin top tmax bottom rvel reduction} {
      if { $wk(invoke,$i) != "" } {
	 set paste($j) $wk(invoke,$i)
      }
   }

   # filter related -----
   if { $wk(invoke,filter) != ""} {
      set filt(type_label) [lindex $wk(filter,list) $wk(invoke,filter)]
      update_filter
   }
   if { $wk(invoke,freq) != ""} {
      set flist [split $wk(invoke,freq) ,]
      for {set i 0} {$i < [llength $flist]} {incr i} {
	 set filt(f[expr $i+1]) [lindex $flist $i]
      }
   }
   if { $wk(invoke,causal) == 1 || $wk(invoke,causal) == 2} {
      set filt(causal) $wk(invoke,causal)
   }
   # sufilter
   if { $wk(invoke,su) != "" } {
      if {$wk(invoke,su)} {
	 set gbl(check,sufilter) 1
      } else {
	 set gbl(check,sufilter) 0
      }
   }
   if { $wk(invoke,sufilter) != "" } {
      if { [file readable $wk(invoke,sufilter)] } {
	 SUfilter::exec_load $wk(invoke,sufilter)
      } else {
	 puts stderr "Cannot read sufilter file, \"$wk(invoke,sufilter)\""
	 exit
      }
   }
   # Gain related -----
   # agc
   if { $wk(invoke,agc) != "" } {
      set paste(amp,agc) $wk(invoke,agc)
   }

   # amp correction
   if { $wk(invoke,ampc) != ""} {
      if { [string tolower $wk(invoke,ampc)] == "none" } {
	 set gbl(check,amp) 0
      } else {
	 set gbl(check,amp) 1
	 set paste(amp,correct_label) $wk(invoke,ampc)
	 update_amp_correct
      }
   }

   # clip 
   if { $wk(invoke,clip) != ""} {
      set paste(amp,cutoff) $wk(invoke,clip)
   }

   # Auto gain
   if { $wk(invoke,autogain) > 0 } {
      set gbl(option,scaling_factor) $wk(invoke,autogain)
      auto_scale_factor
   }


   # pick file -----
   if { $wk(invoke,havepick) == 1 } {
      set file_name(pick) $wk(invoke,pickfn)
   }
   if { [file readable $file_name(pick)] } {
      read_pick $file_name(pick)
   } else {
      set file_name(pick) ""
   }

   # synthetic file -----
   if { $wk(invoke,havesynthe) == 1} {
      if { [file readable $wk(invoke,synthefn)] } {
	 Synthetic::read $wk(invoke,synthefn)
	 set macray(filename) $wk(invoke,synthefn)
      }
   }

   # water wave -----
   if { $wk(invoke,drawwater) == 1 }  {
      # get OBS depth from the file, if possible
      set gbl(obs,depth) [su_get_water_depth]
      # set flag
      set wk(plot,water_wave) 1
   }

   # output PNG/JPEG resolution
   if { $wk(invoke,dpi) != "" }  {
      set print(density) $wk(invoke,dpi)
   }

   # Auto PS mode -----
   if { $wk(invoke,autoPS) } {
      # Make record section
      wm deiconify .cw
      update
      draw_pasteup
      update
      # pick mark label -----
      if { $wk(invoke,plabel) == 1 } {
	 # plot pick mark labels
	 pick_label_plot
      }
      # Print the section to a temporary PostScript file
      set ww [wait_window "Making PostScript..."]
      set tmpps [format "%s/pasteup.%d.ps" $TMPDIR [pid]]
      exec_print_to_file $tmpps
      # Cat the PostScript file
      cat_file $tmpps
      # remove the temporary file
      file delete $tmpps
      # save parameters
      save_resource
      exit
   }

   # Quit if auto-quit option is given -----
   if { $wk(invoke,autoquit) } {
      # save parameters to default file
      save_resource
      # save parameters to a specified file
      if { $wk(invoke,saveparafn) != "" } {
	 save_resource $wk(invoke,saveparafn)
      }
      # quit
      exit
   }

   # Normal startup -----
   while { [winfo ismapped .] == 1} {update}
   if {[check_parameter] != 1} {
      draw_axis  $wk(w,current)
      draw_labels  $wk(w,current)
   }
   update
   wm deiconify .cw
   wm deiconify $wk(w,console)

   # taup/tausum analysis mode -----
   if { $wk(invoke,taup) } {
      # set xrange (slowness range)
      if { $paste(left) < 0 } { set paste(left) 0 }
      if { $paste(right) > 2 } { set paste(right) 1 }
      # set reduction to 0
      set paste(reduction) 0
      # obs depth
      set gbl(obs,depth) [su_get_water_depth]
      # mouse binding
      set gbl(bind) "Tau-P Mode"
      # show tau-p/tau-sum analysis window
      analysis_window
      $wk(w,analysis).tabset select end
   }

   if { $wk(invoke,analysis) } {
      analysis_window
   }

   # Auto draw mode -----
   if { $wk(invoke,autodraw) } {
      draw_pasteup
      # Raise canvas window
      set geo [wm geometry .cw]
      wm withdraw .cw
      update            ; # in case of using mlterm+fvwm-2.5.10....
      wm geometry .cw $geo
      wm deiconify .cw
   }
   # pick mark label -----
   if { $wk(invoke,plabel) == 1 } {
      # plot pick mark labels
      pick_label_plot
   }

   # update wm title
   update_wm_title
}

# --------------------------------------------------------------------
# Set drawing style by the command line 
# --------------------------------------------------------------------
proc set_drawing_style {style} {
   # Global ------------------------------
   global wk gbl

   switch $style {
      "Wiggle" -
      "VA" -
      "VA(R&B)" -
      "VA(w/o wiggle)" -
      "VA(w/o wig RB)" -
      "VD" -
      "Wiggle on VD" -
      "VA on VD" {
	 set gbl(mode_label) $wk(invoke,style)
	 update_mode
      }
      default {
	 puts stderr "ERROR: Invalid drawing style, $style"
	 exit
      }
   }
}

# --------------------------------------------------------------------
# Set drawing style by the command line 
# --------------------------------------------------------------------
proc set_drawing_style2 {style2} {
   # Global ------------------------------
   global paste
   switch -- $style2 {
      0 -
      1 -
      2 -
      3 {
	 set paste(image,mode) $style2
      }
      default {
	 puts stderr "ERROR: Invalid drawing style2, $style2"
	 exit
      }
   }
}

# --------------------------------------------------------------------
# Determine data type automatically and get some info
# --------------------------------------------------------------------
proc auto_type_info {fn} {
   # Global ------------------------------
   global file_name gbl wk CPU_ARCHTECTURE

   # main ------------------------------
   set GUI_flag 0
   if {$fn == ""} {
      # from GUI
      set fn $file_name(wave)
      set GUI_flag 1
      if ![file readable $fn] {
	 tk_messageBox -type ok -message "Cannot read \"$fn\"." -icon error
	 return
      }
   }

   set ftype [identify_file $fn]
   switch -- $ftype {
      SU {
	 set file_name(wave) $fn
	 set gbl(data,type,label) "SU"
	 if {$wk(invoke,mode) == "specified"} {
	    set wk(invoke,mode) specified_both
	 } else {
	    set wk(invoke,mode) default+wavefile
	 }
	 set gbl(obs,depth) [su_get_water_depth]
	 if { $GUI_flag == 0 } {
	    set gbl(ds,mode) 0
	 }
      }
      SEGY {
	 set file_name(wave) $fn
	 set gbl(data,type,label) "SEGY(1Ch)"
	 if { $CPU_ARCHTECTURE == "little" } {
	    set swap_flag [segy_little_or_big $fn]
	 } else {
	    set swap_flag [expr [segy_little_or_big $fn] * -1]
	 }
	 set sgy_data_fmt [segy_binary_format $fn]
	 switch $sgy_data_fmt {
	    1 {
	       # IBM float
	       set gbl(data,byte) [expr 15 * $swap_flag]
	    }
	    2 {
	       # long int
	       set gbl(data,byte) [expr  4 * $swap_flag]
	    }
	    default {
	       puts stderr\
		   "Unsupported SEG-Y data format, $sgy_data_fmt"
	       exit
	    }
	 }
	 set gbl(obs,depth) [su_get_water_depth]
	 if {$wk(invoke,mode) == "specified" } {
	    set wk(invoke,mode) specified_both
	 } else {
	    set wk(invoke,mode) default+wavefile
	 }
	 if { $GUI_flag == 0 } {
	    set gbl(ds,mode) 0
	 }
      }
      RC {
	 # parameter file
	 set wk(invoke,mode) specified
	 set wk(resource_file) $fn
	 if { ![file readable $wk(resource_file)] } {
	    puts stderr "ERROR:\nCan't read \"$wk(resource_file)\".\n"
	    exit
	 }
      }
      PICK {
	 # pick file
	 set wk(invoke,havepick) 1
	 set wk(invoke,pickfn) $fn
      }
      UNKNOWN {
	 #
      }
   }

   if { $GUI_flag } {
      update_data_type
   }
}
# --------------------------------------------------------------------
# Automatic figure title generation
# --------------------------------------------------------------------
proc make_title {} {
   global paste file_name

   # main ------------------------------
   set fn [file normal $file_name(wave)]
   switch -- $paste(label,autotitle) {
      Filename {
	 return [lindex [file split $fn] end]
      }
      Dirname {
	 return [lindex [file split [file dirname $fn]] end]
      }
      Dirname(fullpath) {
	 return [file dirname $fn]	 
      }
      default {
	 return $paste(label,title)
      }
   }
}