# --------------------------------------------------------------------
# balloon : Show ballonn help(tips)
# --------------------------------------------------------------------
# [argument]
# mes   : tips
# x     : mouse cursor position
# y     : mouse cursor position
# --------------------------------------------------------------------
proc balloon {mes x y} {
   global wk

   cancel_balloon
   set wk(balloon,id) [after 200 [list show_balloon $mes $x $y]]
}

# --------------------------------------------------------------------
# cancel_balloon : Cancel ballonn help(tips)
# --------------------------------------------------------------------
proc cancel_balloon {} {
   global wk
   if { [info exists wk(balloon,id)] } {
      after cancel $wk(balloon,id)
      unset wk(balloon,id)
   }
   wm withdraw $wk(balloon,widget)
}

# --------------------------------------------------------------------
# show_balloon : Invoke balloon help(tips)
# --------------------------------------------------------------------
# [argument]
# mes   : tips
# x     : mouse cursor position
# y     : mouse cursor position
# --------------------------------------------------------------------
proc show_balloon {mes x y} {
   global wk

   $wk(balloon,widget).mes configure -text $mes -justify left

   set X [expr $x + 5]
   set Y [expr $y + 5]
 
   wm geometry  $wk(balloon,widget) +$X+$Y
   wm deiconify $wk(balloon,widget)

   raise $wk(balloon,widget)
   unset wk(balloon,id)
}

# --------------------------------------------------------------------
# show position balloon : Invoke position balloon
# --------------------------------------------------------------------
# [argument]
# mes   : tips
# x     : mouse cursor position
# y     : mouse cursor position
# --------------------------------------------------------------------
proc show_position_balloon {mes x y} {
   global wk gbl

   if { $gbl(option,showposition) < 1 } { return }

   $wk(balloon,pos).mes configure -text $mes

   set X [expr $x + 16]
   set Y [expr $y + 16]
 
   wm geometry  $wk(balloon,pos) +$X+$Y
   wm deiconify $wk(balloon,pos)

   raise $wk(balloon,pos)
}

# --------------------------------------------------------------------
# define pop-up help for a widget
# --------------------------------------------------------------------
# w     : widget
# mes   : tips
# --------------------------------------------------------------------
proc define_balloon {w mes} {
   bind $w <Enter> "balloon \"$mes\" %X %Y"
   bind $w <Leave> "cancel_balloon"
}