# --------------------------------------------------------------------
# delete old(more than 24hour ago) files
# --------------------------------------------------------------------
proc delete_old_files {file_list} {
   # Main ------------------------------
   set current_time [clock scan now]
   foreach fn $file_list {
      set create_time [file mtime $fn]
      # older than 1 day (86400sec) ?
      if {$current_time - $create_time > 86400} {
	 catch { file delete -force -- $fn }
      }
   }
}

# --------------------------------------------------------------------
# Clean up previous temporary files in TMPDIR
# --------------------------------------------------------------------
proc clean_old_files {} {
   # Global variables ------------------------------
   global TMPDIR

   # Main ------------------------------
   set flist {}
   catch { set flist [glob [format "%s/pasteup.*" $TMPDIR]   ] }

   # clean all of them
   delete_old_files $flist
}