#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <time.h>

#include "pasteup.h"

/********************************************************************
Read record header file for CHIBA data.
The record header file must be in the format of mkchiba.rb.
********************************************************************/
int read_CHIBA_rh(FILE *fp)
{
    /***** Local Varibales *****/
    int i, j;
    char tmp[12][20], dum[150];
    
    /***** Clear tmp *****/
    for(i=0;i<12;i++){
	for(j=0;j<20;j++){
	    tmp[i][j] = 0;
	}
    }
    
    i=0;
    while(1){      /*** եκǸޤɤ ***/
	if (fgets(dum,120,fp) == NULL){
	    break;
	}
	if (dum[0] == '#') continue;
	sscanf(dum,"%s%s%s%s%s%s%s%s%s%s%s%s",
	       tmp[0],tmp[1],tmp[2],tmp[3],tmp[4],tmp[5],tmp[6],tmp[7],
	       tmp[8],tmp[9],tmp[10],tmp[11]);
/* 	gbl_rh[i].month       = atoi(tmp[1]); */
/* 	gbl_rh[i].jday         = atoi(tmp[2]); */
/* 	gbl_rh[i].hour        = atoi(tmp[3]); */
/* 	gbl_rh[i].min         = atoi(tmp[4]); */
/* 	gbl_rh[i].sec         = atof(tmp[5]); */
	gbl_rh[i].dsec        = 0.0;
	gbl_rh[i].x           = atof(tmp[6]);
	gbl_rh[i].sampling    = atof(tmp[7]);
	gbl_rh[i].start_point = (atoi(tmp[8]) - 1)*8192;
	/* end_point is number of samples */
	gbl_rh[i].end_point   = ( (atoi(tmp[9])-1)*8192 + atoi(tmp[10]) )/8;
	gbl_rh[i++].swdep     = 0.0;
    }
    return(i);
}

/*
  --------------------------------------------------------------------
*/

int read_CHIBA_data(float *a, double *t, FILE *fp, int ch,
		    int data_point1, int data_point2,
		    double start_time, double end_time,
		    double sampling, double dt_clock)
/********************************************************************
Read chiba waveform data
--------------------------------------------------------------------
ꤷ[stat_time:end_time]ΥǡڤФ
--------------------------------------------------------------------
[arguments]
a           : amp series.
t           : Time series.
fp          : input data file pointer.
ch          : output channel
data_point1 : start point
data_point2 : number of samples
start_time  : start time
end_time    : end time
sampling    : sampling rate in Hz
dt_clock    : dt in second.
********************************************************************/
{
    /********** Local Variables **********/
    int i, i_start, i_end, count, address;
    char buf[72000]; /*** 3byte 100Hz  4ʬ֤٤ɤ̤ ***/
    
    /********** Local Function **********/
    float mkval(char *buf, int num, int data_type);
    
    /**************************/
    /********** Main **********/
    /**************************/

    ch = ch -1;
    
    /***** Compute address to read *****/
    /** ɤ߽ФϻΥǥå **/
    if ( start_time + dt_clock >= 0.0 ) {
	i_start = (start_time + dt_clock )*sampling;
    } else {
	i_start = 0;
    }
    /** ɤ߽ФλΥǥå **/
    i_end = ceil((end_time + dt_clock)*sampling);
    if (i_end > data_point2)
	i_end = data_point2;
    count = i_end - i_start;
    if (count < 1) return(0);
    address = data_point1 + i_start * 4 * 2; /** 4ch*2byte fix **/

    /***** ǡɤ߽Ф *****/
    fseek(fp, address, SEEK_SET);
    for(i=0;i<count;i++) {
	fread(buf, sizeof(char), 4*2, fp); /** 4ch*2byte fix **/
	t[i] = (double)(i + i_start)/sampling - dt_clock;
	a[i] = mkval(buf, ch, 2);
    }
    return(count);
}

/*
  --------------------------------------------------------------------
*/

int get_CHIBA_year()
/********************************************************************
 Return the year of observation :
 Chiba data has no year information!
********************************************************************/
{
    /********** Local Variables **********/

    /**************************/
    /********** Main **********/
    /**************************/
    return(-1);
}
