# --------------------------------------------------------------------
# Search CHIBA waveform data file in the specified directory
# Return the first filename in the alphabetic order.
# --------------------------------------------------------------------
# [arguments]
# dir : directory for search.
# --------------------------------------------------------------------
proc chiba_search_datafile {dir} {
    set list [glob -nocomplain -dir $dir "*.ube" "*.dat"]
    if { [llength $list] < 1 } {
	return "./data.ube"
    } else {
	return [lindex $list 0]
    }
}

# --------------------------------------------------------------------
# Search CHIBA record header file in the specified directory
# Return the first filename in the alphabetic order.
# --------------------------------------------------------------------
# [arguments]
# dir : directory for search.
# --------------------------------------------------------------------
proc chiba_search_rhfile {dir} {
   set list [glob -nocomplain -dir $dir "*.rh" "rh.*"]
   if { [llength $list] < 1 } {
      return "./rh.dat"
   } else {
      return [lindex $list 0]
   }
}
