# --------------------------------------------------------------------
# convert_data_into_su
# --------------------------------------------------------------------
proc convert_data_into_su {} {
   # Global variable
   global gbl wk custom file_name
   
   # Main --------------------
   # SU?
   if { $gbl(data,type,label) == "SU" } {
      tk_messageBox -icon warning -type ok \
	  -message "You do not need to convert yoru SU file into SU-format..."
      return
   }

   set w .convert_window
   if [raise_window $w] { return }
   toplevel $w
   wm title $w "PasteUP: Convert raw-data"

   # title frame --------------------
   set titlef [title_frame $w.title_frame "Pasteup: Convert raw-data window"]

   # parameter frame ------------------------------
   set pf $w.parameter_frame
   frame $pf

   # output filename ----------
   set dir [file dirname $file_name(wave)]
   set fn [file rootname [file tail $file_name(wave)]]
   set wk(conv,output_fn) [format "%s/%s.su" $dir $fn]
   filename_hscroll_frame $pf output_filename "output SU file" \
       wk(conv,output_fn) 60 save su

   # Button frame ----------------------------------------
   set bf [button_frame $w $w.button_frame "Convert" "exec_convert"]
   
   # Packing ----------
   pack $titlef $pf $bf -side top -fill x -expand 1
}

# --------------------------------------------------------------------
# exec_convert
# --------------------------------------------------------------------
proc exec_convert {} {
   # Global variable
   global gbl wk file_name fp filt paste TMPDIR
   
   # Main --------------------
   # check overwrite?
   if { [file exists $wk(conv,output_fn)] } {
      set ans [tk_messageBox -icon question -type okcancel \
		   -message "The output file already exists.  Are you sure to overwite it?"]
      if { $ans == "cancel"} {return}
   }

   # execution
   set ww [wait_window "now computing..."]
   convertSU

   # fin
   update
   destroy $ww
   destroy .convert_window
}
