# --------------------------------------------------------------------
# Duplicate current canvas image
# --------------------------------------------------------------------
proc duplicate_canvas {} {
   # Global variables ----------
   global gbl paste wk
   
   # Main ------------------------------
   set w .duplicate
   set f $w.frame
   set c $f.canvas
   set h $f.hscroll
   set v $f.vscroll
   set b $w.buttons
   if [raise_window $w] {
      # nothing 
   } else {
      # Invoke new window
      toplevel $w
      wm title $w "Pasteup:Reference Image"
      wm minsize $w 300 300

      # button frame
      frame $b
      button $b.dismiss -text "dismiss" -command "destroy $w"
      pack $b.dismiss
      pack $b -side bottom -fill x

      # canvas frame
      frame $f
      pack $f -side top -fill both -expand yes
      set wd $paste(canvas_width)
      set hg $paste(canvas_height)
      canvas $c -relief groove  -background white -highlightthickness 0\
	  -width $wd -height $hg -scrollregion "0 0 $wd $hg"\
	  -xscrollcommand "$h set" -yscrollcommand "$v set"
      scrollbar $h -orient horiz -command "$c xview" -width 10
      scrollbar $v -command "$c yview" -width 10
      grid $c -in $f -row 0 -column 0 -rowspan 1 -columnspan 1 -sticky news
      grid $v -row 0 -column 1 -rowspan 1 -columnspan 1 -sticky news
      grid $h -row 1 -column 0 -rowspan 1 -columnspan 1 -sticky news
      grid rowconfig    $f 0 -weight 1 -minsize 0
      grid columnconfig $f 0 -weight 1 -minsize 0

      # binding
      bind $w <Right>            "hscroll_canvas $c  1"
      bind $w <Left>             "hscroll_canvas $c -1"
      bind $w <Down>             "vscroll_canvas $c  1"
      bind $w <Up>               "vscroll_canvas $c -1"
      bind $c <Control-Button-4> "hscroll_canvas $c -1"
      bind $c <Control-Button-5> "hscroll_canvas $c  1"
      bind $c <Button-4>         "vscroll_canvas $c -1"
      bind $c <Button-5>         "vscroll_canvas $c  1"
      bind $w <Control-q>        "destroy $w"
      bind $w <Control-c>        "destroy $w"
      bind $w <Control-w>        "wm iconify $w"

      wm geometry $w 500x500
   }
   # clear canvas
   $c delete all
   # duplicate image
   set org $wk(w,canvas,c)
   foreach tag [$org find withtag all] {
      set com "$c create"
      # type
      lappend com [$org type $tag]
      # coordinates
      lappend com [$org coords $tag]
      # options
      foreach opt [$org itemconf $tag] {
	 set val [lindex $opt 4]
	 set o [lindex $opt 0]
	 if { $o == "-image"} {
	    set orgimage $val
	    set val duplicate_image
	    image create photo $val
	    $val copy $orgimage
	 }
	 if { [string compare [lindex $opt 3] $val] != 0 } { 
	    lappend com [lindex $opt 0] $val
	 }
      }
      # duplicate
      eval $com
   }

   # update canvas size
   $c conf -width $paste(canvas_width) -height $paste(canvas_height)\
       -scrollregion "0 0 $paste(canvas_width) $paste(canvas_height)"
}

