#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include "tcl.h"
#include "pasteup.h"


/*
  --------------------------------------------------------------------
*/

int pasteup_encodeProc(
		       ClientData clientData, /* not used                */
		       Tcl_Interp *interp,    /* current tcl interpreter */
		       int objc,              /* number of arguments     */
		       Tcl_Obj* CONST objv[]  /* arguments               */
		   )
{
    /***** Variables *****/
    char *str;
    char new[65];
    unsigned int a[65];
    int len_org, len_new, rem;
    int i, j;

    /******************** Main ********************/
    void usage () {
	Tcl_AppendResult
	    (interp,
	     "usage :\n",
	     "   encode string\n",
	     (char *)NULL);
    };

    /***** Check arguments *****/
    if(objc != 2){
	usage();
	return TCL_ERROR;
    }

    /***** get string *****/
    str = Tcl_GetStringFromObj(objv[1], NULL);

    /***** encoding *****/
    strncpy(new, str, 32);
    len_org = strlen(str);
    strncat(new, ENCODE_STRING, 32);
    while( (len_new=strlen(new)) <32){
	strncat(new, new, 32);
    }
    for(i=0;i<len_new;i++){
	a[i] = new[i] + new[len_new -i -1]*i;
    }
    for(i=0;i<len_org;i++){
	for(j=0;j<len_new;j++){
	    a[j] = a[j] * (new[i] / 10.0);
	}
    }
    
    /* convert into ASCII strings */
    rem = 0;
    for(i=0;i<32;i++) {
	new[i] = (a[i] + rem)%94 + 33;
	rem = a[i]/94;
    }
    new[i] = 0;

    /***** Convert cx into graph coordinate gx *****/
    Tcl_SetObjResult(interp, Tcl_NewStringObj(new, -1));
    return TCL_OK;
}
