# --------------------------------------------------------------------
# opening_logo : show the opening logo
# --------------------------------------------------------------------
proc opening_logo {} {
   # Global variables ------------------------------
   global wk

   # Main ------------------------------
   # coordinate
   set x [expr [winfo screenwidth .]/2 - 160]
   set y [expr [winfo screenheight .]/2 - 100]
   # wm settings
   wm geometry . +$x+$y
   # show logo
   label .logo -image logo
   pack .logo
   wm overrideredirect . 1
   update
   after $wk(invoke,logo_duration) { wm withdraw .}
}

# --------------------------------------------------------------------
# help_about : show version and copyrights info
# --------------------------------------------------------------------
proc help_about {} {
   # Global variables
   global gbl wk
   
   # Main --------------------------------------------------
   set h .help_about
   # check existing help about window
   if [raise_window $h] { return }

   # invoke help about window
   toplevel $h
   wm title $h "PasteUp:About"
   wm over $h 1
   set x [expr [winfo screenwidth .]/2 - 160]
   set y [expr [winfo screenheight .]/2 - 200]
   # wm settings
   wm geometry $h +$x+$y
   
   basic_bindings $h
   
   # logo --------------------
   button $h.logo -image logo -command "destroy $h"

   # version info --------------------
   set hc $h.contents
   text $hc -height 12 -width 35 -relief flat -wrap word

   # tag
   $hc tag configure center -justify center

   # contents
   $hc insert end \
       "\n\nPasteup Program Version. $wk(VERSION)\
	    \n\nCopyright(C) FUJIE Gou, 1997-2008." center
   $hc insert end "\n\n Special thanks to,\n" center
   $hc insert end " Dr. K. MOCHIZUKI\n" center
   $hc insert end " Dr. K. MURASE" center
   $hc conf -state disabled
   
   # packing
   pack $h.logo $h.contents -side top -fill both -expand yes
   bind $h <Control-q> "destroy $h"
}

# --------------------------------------------------------------------
# help_browser : invoke browser to show help
# --------------------------------------------------------------------
proc help_browser {} {
   # Global variables
   global gbl DATADIR
   
   # Main --------------------------------------------------
   eval {exec} $gbl(help,browser) $DATADIR/help/index.html &
}

# --------------------------------------------------------------------
# check whether stable or bleeding edge version
# --------------------------------------------------------------------
proc check_stable {} {
   global stable_version env wk DATADIR

   # if stable
   if { [info exists stable_version] && $stable_version == "yes" } return

   # when bleeding edge version ------------------------------
   # encoding user name
   set user [encode $env(USER)]
   # check registeration file
   if { [file readable $DATADIR/register.txt] } {
      set fp [open $DATADIR/register.txt]
      while { [gets $fp line] >= 0 } {
	 if { $line == $user } {
	    close $fp
	    return
	 }
      }
      close $fp
   }
   # exit with warning messages.
   puts stderr "\nThis is Pasteup $wk(VERSION) which is under development."
   puts stderr "Use stable version of Pasteup instead of this version.\n"
   exit
}
