global_settings { 
  assumed_gamma 1.8
  max_trace_level 7
}

#include "colors.inc"
#include "shapes.inc"
#include "textures.inc"
#include "glass.inc"
#include "metals.inc"
#include "stones.inc"
#include "woods.inc"
#include "skies.inc"
#include "woods.inc"

camera {
  location <0.0, 0.0, -100.0>
//  direction <0.0, 0.0, 2.0>
//  up  <0.0, 1.0, 0.0>
//  right <4/3, 0.0, 0.0>
  look_at <0.0, 0.0, 0.0>
}

// Light
light_source {<0.0, 50.0, -200.0> colour red 1 green .6 blue .6}

// Sky
#declare Pasteup_Cloud =
sky_sphere {
  pigment {
    gradient y
    pigment_map {
      [0.00 rgb <0.8, 0.8, 0.9> ]
      [0.15 SkyBlue ]            
      [0.35 P_Cloud4 ]
    }
  }
}
#declare New_Sky = sky_sphere { Pasteup_Cloud }
sky_sphere { New_Sky }

// Ocean
plane { y, -10.0
  texture {
    T_Chrome_3E
    normal {
      waves 0.05
      frequency 1000.0
      scale 1000.0
    }
  }
}

// Application name
text { ttf "/usr/local/share/OfficeFont/arialn.ttf", "Pasteup", 1.0, 0.0
  translate <-1.5, 0.7, 0.0>
  texture { T_Chrome_4D }
  scale <20, 20, 6>
  rotate <15, -15, 0>
}

// Author
text { ttf "/usr/local/share/OfficeFont/tahoma.ttf", "by FUJIE Gou", 0.8, 0
  translate <-0.8, -1, 0>
  // texture { T_Chrome_3C }
  texture { T_Brass_3C }
  scale <8, 8, 3>
  rotate <15, -5, 0>
}
