#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include "pasteup.h"

static void **alloc2(int n1, int n2, int size)
{
    int i;
    void **p;

    if ((p=(void**)malloc(n2*sizeof(void*)))==NULL)return NULL;
    if ((p[0]=(void*)malloc(n2*n1*size))==NULL) {
        free(p);
        return NULL;
    }
    for(i=0;i<n2;i++) p[i]=(char*)p[0]+size*n1*i;
    return p;
}

float **fmalloc2(int nx, int nz)
{
    return((float**)alloc2(nx, nz, sizeof(float)));
}

static void free2 (void **p)
{
    free(p[0]);
    free(p);
}

void ffree2(float **p)
{
    free2((void**)p);
}

int pasteup_mallocProc(
		       ClientData clientData, /* not used                */
		       Tcl_Interp *interp,    /* current tcl interpreter */
		       int objc,              /* number of arguments     */
		       Tcl_Obj* CONST objv[]  /* arguments               */
		       )
{
    /******************** Main ********************/
    void usage () {
	Tcl_AppendResult
	    (interp, "wrong usage :\n malloc",(char *)NULL);
    };
    /***** Check arguments *****/
    if(objc != 1){
	usage();
	return TCL_ERROR;
    }

    /***** read arguments *****/
    TCL_GET(Int, wk, "invoke,maxsample", maxsample);
    TCL_GET(Int, wk, "invoke,maxtrace", maxtrace);

    /***** memory allocation *****/
    if( NULL==(gbl_rh = malloc(maxtrace * sizeof( struct record_header ) ))||
	NULL==(gbl_a  = fmalloc2(maxsample, maxtrace)) ||
	NULL==(gbl_t  = malloc(maxtrace * sizeof(float))) ||
	NULL==(gbl_n  = malloc(maxtrace * sizeof(int)))	) {
	return TCL_ERROR;
    }

    /***** initialize global variables *****/
    total_shot = 0;
    return TCL_OK;
}

int realloc_global_variable()
{
    int i;
    
    /* 1D arrays */
    if( NULL==(gbl_rh = realloc(gbl_rh,
				maxtrace * sizeof( struct record_header ) ))||
	NULL==(gbl_t  = realloc(gbl_t,
				maxtrace * sizeof(float))) ||
	NULL==(gbl_n  = realloc(gbl_n,
				maxtrace * sizeof(int)))
	) {
	return(1);
    }
    /* 2D array */
    if( NULL==(gbl_a = (float **)realloc(gbl_a, maxtrace * sizeof(float *))) )
	return(1);
    if( NULL==(gbl_a[0]=(float *)realloc(gbl_a[0],
					 maxtrace*maxsample*sizeof(float))) )
        return(1);
    for(i=0;i<maxtrace;i++)
	gbl_a[i]=(float *) ((char *)gbl_a[0] + sizeof(float)*maxsample*i);

    fprintf(stderr, "reallocation ok: %d\n", maxtrace); fflush(stderr);
    return(0);
}
