#include <stdio.h>
#include <string.h>

#define _PASTEUP_MAIN_ 1

/***** local header file *****/
#include "pasteup.h"

/***** Declare global variables *****/
int total_shot;                  /* total shot/trace number */
struct record_header *gbl_rh;    /* record header  */
float **gbl_a;                   /* wave form data */
float *gbl_t;                    /* start time     */
int *gbl_n;                      /* number of samples */
int maxtrace;                    /* max trace in a file */
int maxsample;                   /* max samples per a trace to show */

extern int
pasteup_pickProc(
		 ClientData clientData, /* not used                */
		 Tcl_Interp *interp,    /* current tcl interpreter */
		 int objc,              /* number of arguments     */
		 Tcl_Obj* CONST objv[]  /* arguments               */
		 );

extern int
pasteup_coordProc(
		  ClientData clientData, /* not used                */
		  Tcl_Interp *interp,    /* current tcl interpreter */
		  int objc,              /* number of arguments     */
		  Tcl_Obj* CONST objv[]  /* arguments               */
		  );

extern int
pasteup_getrhProc(
		  ClientData clientData, /* not used                */
		  Tcl_Interp *interp,    /* current tcl interpreter */
		  int objc,              /* number of arguments     */
		  Tcl_Obj* CONST objv[]  /* arguments               */
		  );

extern int
pasteup_getwaveProc(
		    ClientData clientData, /* not used                */
		    Tcl_Interp *interp,    /* current tcl interpreter */
		    int objc,              /* number of arguments     */
		    Tcl_Obj* CONST objv[]  /* arguments               */
		    );

extern int
pasteup_getinterpProc(
		      ClientData clientData, /* not used                */
		      Tcl_Interp *interp,    /* current tcl interpreter */
		      int objc,              /* number of arguments     */
		      Tcl_Obj* CONST objv[]  /* arguments               */
		      );

extern
int pasteup_getampProc(
		       ClientData clientData, /* not used                */
		       Tcl_Interp *interp,    /* current tcl interpreter */
		       int objc,              /* number of arguments     */
		       Tcl_Obj* CONST objv[]  /* arguments               */
		       );
extern
int pasteup_convertSUProc(
			  ClientData clientData, /* not used                */
			  Tcl_Interp *interp,    /* current tcl interpreter */
			  int objc,              /* number of arguments     */
			  Tcl_Obj* CONST objv[]  /* arguments               */
			  );
extern
int pasteup_subplotProc(
			ClientData clientData, /* not used                */
			Tcl_Interp *interp,    /* current tcl interpreter */
			int objc,              /* number of arguments     */
			Tcl_Obj* CONST objv[]  /* arguments               */
			);
extern int
pasteup_linepickProc(
		     ClientData clientData, /* not used                */
		     Tcl_Interp *interp,    /* current tcl interpreter */
		     int objc,              /* number of arguments     */
		     Tcl_Obj* CONST objv[]  /* arguments               */
		     );

extern int
pasteup_gettraceProc(
		     ClientData clientData, /* not used                */
		     Tcl_Interp *interp,    /* current tcl interpreter */
		     int objc,              /* number of arguments     */
		     Tcl_Obj* CONST objv[]  /* arguments               */
		     );

extern int
pasteup_mallocProc(
		   ClientData clientData, /* not used                */
		   Tcl_Interp *interp,    /* current tcl interpreter */
		   int objc,              /* number of arguments     */
		   Tcl_Obj* CONST objv[]  /* arguments               */
		   );
extern int
pasteup_raysProc(
		 ClientData clientData, /* not used                */
		 Tcl_Interp *interp,    /* current tcl interpreter */
		 int objc,              /* number of arguments     */
		 Tcl_Obj* CONST objv[]  /* arguments               */
		 );
extern int
pasteup_encodeProc(
		   ClientData clientData, /* not used                */
		   Tcl_Interp *interp,    /* current tcl interpreter */
		   int objc,              /* number of arguments     */
		   Tcl_Obj* CONST objv[]  /* arguments               */
		   );

int Pasteup_Init(Tcl_Interp* interp){
#ifdef USE_TCL_STUBS
    if (Tcl_InitStubs(interp, "8.1", 0) == NULL) {
	return TCL_ERROR;
    }
#endif
#ifdef USE_TK_STUBS
    if (Tk_InitStubs(interp, "8.1", 0) == NULL) {
	return TCL_ERROR;
    }
#endif
    Tcl_CreateObjCommand(interp, "pick",  (Tcl_ObjCmdProc *)pasteup_pickProc,
			 (ClientData)NULL, (Tcl_CmdDeleteProc *)NULL);
    Tcl_CreateObjCommand(interp, "coord",  (Tcl_ObjCmdProc *)pasteup_coordProc,
			 (ClientData)NULL, (Tcl_CmdDeleteProc *)NULL);
    Tcl_CreateObjCommand(interp, "getrh", (Tcl_ObjCmdProc *)pasteup_getrhProc,
			 (ClientData)NULL, (Tcl_CmdDeleteProc *)NULL);
    Tcl_CreateObjCommand(interp, "getwave",
			 (Tcl_ObjCmdProc *)pasteup_getwaveProc,
			 (ClientData)NULL, (Tcl_CmdDeleteProc *)NULL);
    Tcl_CreateObjCommand(interp, "getinterp",
			 (Tcl_ObjCmdProc *)pasteup_getinterpProc,
			 (ClientData)NULL, (Tcl_CmdDeleteProc *)NULL);
    Tcl_CreateObjCommand(interp, "gettrace",
			 (Tcl_ObjCmdProc *)pasteup_gettraceProc,
			 (ClientData)NULL, (Tcl_CmdDeleteProc *)NULL);
    Tcl_CreateObjCommand(interp, "getamp",
			 (Tcl_ObjCmdProc *)pasteup_getampProc,
			 (ClientData)NULL, (Tcl_CmdDeleteProc *)NULL);
    Tcl_CreateObjCommand(interp, "convertSU",
			 (Tcl_ObjCmdProc *)pasteup_convertSUProc,
			 (ClientData)NULL, (Tcl_CmdDeleteProc *)NULL);
    Tcl_CreateObjCommand(interp, "subplot",
			 (Tcl_ObjCmdProc *)pasteup_subplotProc,
			 (ClientData)NULL, (Tcl_CmdDeleteProc *)NULL);
    Tcl_CreateObjCommand(interp, "linepick",
			 (Tcl_ObjCmdProc *)pasteup_linepickProc,
			 (ClientData)NULL, (Tcl_CmdDeleteProc *)NULL);
    Tcl_CreateObjCommand(interp, "malloc",
			 (Tcl_ObjCmdProc *)pasteup_mallocProc,
			 (ClientData)NULL, (Tcl_CmdDeleteProc *)NULL);
    Tcl_CreateObjCommand(interp, "rays", (Tcl_ObjCmdProc *)pasteup_raysProc,
			 (ClientData)NULL, (Tcl_CmdDeleteProc *)NULL);
    Tcl_CreateObjCommand(interp, "encode",(Tcl_ObjCmdProc *)pasteup_encodeProc,
			 (ClientData)NULL, (Tcl_CmdDeleteProc *)NULL);
    return Tcl_PkgProvide(interp, "pasteup", "1.9.1.0");
}
