#include <stdio.h>
#include "pasteup.h"

/********************************************************************
Read num-th data from array "buf"
********************************************************************/
float mkval(char *buf, int num, int bfmt)
{
    /***** Variables*****/
    int i, j;
    int val;

    union c_and_f {
	float f;
	char buf[4];
    } dat;

    /***** Main *****/
    switch(bfmt){
	case FMT_4BYTE_FLOAT:
	    i = num*4;
	    for(j=0;j<4;j++) dat.buf[j] = buf[i + j];
	    return(dat.f);
	case FMT_2BYTE_INT:
	    i = num*2;
	    val = ((buf[i]<<24) >>16) | (buf[i+1]&0x000000ff);
	    return((float)val);
	    break;
	case FMT_3BYTE_INT:
	    i = num*3;
	    val =
		(buf[i]<<16)|((buf[i+1]<<8)&0x0000ff00)|(buf[i+2]&0x000000ff);
	    return((float)val);
	    break;
    }
    return(0.0);
}

/********************************************************************
Convert "buf"(char) into float
********************************************************************/
float mkval2(char *buf, int bfmt)
{
    /***** Variables*****/
    int j, val;

    union c_and_f {
	float f;
	char buf[4];
    } dat;

    /***** Main *****/
    switch(bfmt) {
	case FMT_4BYTE_FLOAT:
	    for(j=0;j<4;j++) dat.buf[j] = buf[j];
	    return(dat.f);
	case FMT_2BYTE_INT:
	    val = ((buf[0]<<24) >>16) | (buf[1]&0x000000ff);
	    return((float)val);
	    break;
	case FMT_3BYTE_INT:
	    val = (buf[0]<<16)|((buf[1]<<8)&0x0000ff00)|(buf[2]&0x000000ff);
	    return((float)val);
	    break;
	case FMT_3BYTE_INT_SW:
	    val = (buf[2]<<16)|((buf[1]<<8)&0x0000ff00)|(buf[0]&0x000000ff);
	    return((float)val);
	    break;
    }
    return(0.0);
}
