# --------------------------------------------------------------------
# Start select a rectangle for amplitude evaluation
# --------------------------------------------------------------------
proc amp_start {pick_x pick_y} {
   # global --------------------
   global wk paste amp_rect
   
   # main --------------------
   set amp_rect(status) on
   set amp_rect(x1) [$wk(w,canvas,c) canvasx $pick_x]
   set amp_rect(y1) [$wk(w,canvas,c) canvasy $pick_y]
   
   # temporal binding
   bind $wk(w,canvas,c) <B2-Motion> {
      amp_motion %x %y
   }
   bind $wk(w,canvas,c) <ButtonRelease-2> {
      amp_end %x %y
   }
}

# --------------------------------------------------------------------
# now selecting a rectangle for amplitude evaluation
# --------------------------------------------------------------------
proc amp_motion {x y} {
   # global --------------------
   global wk amp_rect
   
   # main --------------------
   if {[string compare $amp_rect(status) "on"] != 0} {
      bind $wk(w,canvas,c) <B2-Motion> ""
      return;
   }
   # draw a temporal rectangle
   catch {$wk(w,canvas,c) delete temp_mark}
   $wk(w,canvas,c) create rectangle $amp_rect(x1) $amp_rect(y1)\
       [$wk(w,canvas,c) canvasx $x] [$wk(w,canvas,c) canvasy $y]\
       -outline red -tags temp_mark -width 2
}

# --------------------------------------------------------------------
# Mouse button release : Amplitude rectangle 
# --------------------------------------------------------------------
proc amp_end {pick_x pick_y} {
   # Global --------------------
   global wk amp_rect paste
   
   # Main --------------------
   # Final point
   set amp_rect(x2) [$wk(w,canvas,c) canvasx $pick_x]
   set amp_rect(y2) [$wk(w,canvas,c) canvasy $pick_y]
   
   # Highlight selected region
   $wk(w,canvas,c) delete temp_mark
   $wk(w,canvas,c) create rectangle $amp_rect(x1) $amp_rect(y1)\
       $amp_rect(x2) $amp_rect(y2)\
       -outline green -tags amp_mark -width 2
   
   # Chnage binding
   bind $wk(w,canvas,c) <B2-Motion> ""
   bind $wk(w,canvas,c) <ButtonRelease-2> ""
   
   # Convert display-coordinate into graph coordinate
   set x1 [coord cx2gx $amp_rect(x1)]
   set x2 [coord cx2gx $amp_rect(x2)]
   set t1 [coord cy2gt $amp_rect(y1)]
   set t2 [coord cy2gt $amp_rect(y2)]
   
   # Report results to the message window
   print_message\
       [format "(%f,%f)-(%f,%f) Red.V.=%fKm/s.  Maximum Amplitude= %f\n"\
	    $x1 $t1 $x2 $t2 $paste(reduction) [max_amplitude $x1 $x2 $t1 $t2]]
}

# --------------------------------------------------------------------
# Erase amplitude rectangle
# --------------------------------------------------------------------
proc clear_amp_rect {} {
   # Global --------------------
   global wk
   
   # Main --------------------
   catch {$wk(w,canvas,c) delete amp_mark}
}

