# --------------------------------------------------------------------
# Convert pick types
# --------------------------------------------------------------------
proc pickedit_type_conversion {} {
   # global --------------------
   global wk pick pm
   
   # main --------------------
   # preserve undo info
   undo_stack

   # conversion
   set pm [pick convert $pm $wk(pickedit,from) $wk(pickedit,into)]
   plot_pick_marks 0
   set mark_modification 1
   
   # report
   print_message [format "pick type conversion %d --> %d.\n"\
		      $wk(pickedit,from) $wk(pickedit,into)]
}

# --------------------------------------------------------------------
# Delete selected one pick type
# --------------------------------------------------------------------
proc pickedit_delete_one_type {} {
   # global --------------------
   global wk pick pm
   
   # main --------------------
   # preserve undo info
   undo_stack

   # delete
   set before [llength $pm]
   set pm [pick delete $pm $wk(pickedit,del)]
   plot_pick_marks 0
   set mark_modification 1

   # report
   print_message [format "%d picks are deleted.\n"\
		      [expr $before - [llength $pm]]]
}

