# --------------------------------------------------------------------
# Set offset range automatically
# --------------------------------------------------------------------
proc auto_offset_range {width} {
   # global variables ------------------------------
   global gbl paste wk
   
   # main  ------------------------------
   set wk(condition) [check_same_rh_condition]
   set minmax [getrh minmax]
   set min [lindex $minmax 0]
   set max [lindex $minmax 1]
   
   # Determine left and right end
   if { $min >= $max } { return }

   # Adjust min and max for the tic interval
   set min [expr (int( $min/$gbl(xtic_int) ) - 1) * $gbl(xtic_int)]
   set max [expr (int( $max/$gbl(xtic_int) ) + 1) * $gbl(xtic_int)]

   # if width == "" then all mode, otherwise (left+width)km range is adopted
   if {$width == ""} {
      set paste(left) $min
      set paste(right) $max
   } else {
      set paste(left) $min
      set paste(right) [expr $min + $width]
   }
   
   # puts status
   print_message "Set x-range automatically. ( $min : $max )\n"
}