#ifndef _RECORD_HEADER_H
#define _RECORD_HEADER_H 1

#include <time.h>

/********************************************************************
Trace header information
********************************************************************/
struct record_header {
    /* parameters for drawing */
    int start_point;           /* trace body start point in the file        */
    int end_point;             /* trace body end point in the file          */
    float sampling;            /* sampling rate (Hz)                        */
    float dsec;                /* difference between shot and first sample  */
    float x;                   /* x-axis data                               */
    float offset;              /* offset distance in km                     */
    float shift;               /* shot time shift for display (sec)         */
    /* parameters (not for drawing) */
    int hw[5];                 /* tracl, traclr, tracf, fldr and ep         */
    short int counit;          /* coordinate unit                           */
    short int scalco;          /* scale for coordinates                     */
    int sx, sy;                /* shot position                             */
    int gx, gy;                /* receiver position                         */
    int sdepth;                /* shot depth (meter)                        */
    int swdep;                 /* shot water depth (meter)                  */
    int gwdep;                 /* receiver water depth (meter)              */
    time_t st;                 /* shot time (UNIX time)                     */
    float msec;                /* shot time (milisecond)                    */
};

#endif  /* !_RECORD_HEADER_H */
