proc register_su_modules {com opt} {
   # global
   global wk

   # main --------------------------------------------------
   if {[llength $com] > 0} {
      if {[llength $opt] > 0} {
	 lappend com $opt
      }
      lappend wk(SU,module_list) $com
   }
}

proc define_su_modules {} {
   # global
   global wk DATADIR

   # main --------------------------------------------------
   set wk(SU,module_list) {}
   set com {}
   set opt {}
   set fp [open "$DATADIR/su_modules.dat"]
   while { [gets $fp line] >= 0 } {
      set d [mysplit $line]
      if {[llength $d] < 2} { continue }
      if { [ string match "%*" $line] == 1 } {
	 # % command
	 switch -- [lindex $d 0] {
	    %group {
	       # new group
	       register_su_modules $com $opt
	       set com {}
	       set gn [lrange $d 1 end]
	       lappend wk(SU,module_list) "- \"$gn\""
	    }
	    %com {
	       # new command in this group
	       register_su_modules $com $opt
	       set com [list [lindex $d 1] [lrange $d 2 end]]
	       set opt {}
	    }
	    default {
	       # comment
	       continue
	    }
	 }
      } else {
	 if { [llength $d] < 3 } { continue }
	 # option for this command
	 lappend opt $line
      }
   }
   if {[llength $com] > 0} {
      if {[llength $opt] > 0} {
	 lappend com $opt
      }
      lappend wk(SU,module_list) $com
   }
}
