#include <stdio.h>
#include <time.h>

#include "pasteup.h"

/********************************************************************
  Output 4byte-float value function.
  ********************************************************************/
static void putvalf(FILE *fp, float val)
{
     fwrite(&val, 4, 1, fp);
}

/*
--------------------------------------------------------------------
*/

/********************************************************************
  Output 24bit-value function by Dr. Mochizuki.
  ********************************************************************/
static void putval24(FILE *fp,long int val)
{
  char chr1, chr2, chr3;
  long buffer;

  buffer = val;
  chr1  = (buffer>>16)&(0x000000ff);
  chr2  = (buffer>>8)&(0x000000ff);
  chr3  = (buffer)&(0x000000ff);
  putc(chr1,fp);
  putc(chr2,fp);
  putc(chr3,fp);

  return;
}

/*
--------------------------------------------------------------------
*/

/********************************************************************
  Output 16bit-value function by Dr. Mochizuki.
  ********************************************************************/
static void putval16(FILE *fp, int val)
{
  char  ret10, ret20;
  short ret1, ret2, ret11;
  
  ret2  = (0x000000ff) & val;
  ret20 = (char)ret2;
  ret1  = val >> 8;
  ret11 = (0x000000ff) & ret1;
  ret10 = (char)ret11;
  putc(ret10, fp);
  putc(ret20, fp);
}

/*
--------------------------------------------------------------------
*/

void write_kasalab_trace(FILE *fp, float *a, int byte, int sample)
/********************************************************************
 Write one trace body to the file in KASA-lab format.
--------------------------------------------------------------------
<arguments>
fp         : file pointer for output
a          : waveform
byte       : data byte 2, 3 or 4.
sample     : sample number
********************************************************************/
{
     /********** Local Variables **********/
     int j;

     /********** Main **********/
     switch(byte) {
	  case 4: /** 4byte float **/
	       for(j=0;j<sample;j++){
		    putvalf(fp, a[j]);
	       }
	       break;
	  case 3: /** 3byte integer **/
	       for(j=0;j<sample;j++){
		    putval24(fp, (long int)a[j]);
	       }
	       break;
	  case 2: /** 2byte integer **/
	       for(j=0;j<sample;j++){
		    putval16(fp, (short int)a[j]);
	       }
	       break;
	  default:
	       break;
     }
}
